package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysMessage;
import cn.estsh.i3plus.pojo.platform.bean.SysRefUserMessage;

import java.util.List;

/**
 * @Description : 消息业务服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 17:10
 * @Modify :
 **/
public interface ISysMessageService {

    /**
     * 添加消息
     * @param sysMessage
     */
    SysMessage insertSysMessage(SysMessage sysMessage);

    /**
     * 删除消息
     * @param id
     */
    void deleteSysMessageById(Long id);

    /**
     * 修改消息
     * @param sysMessage
     */
    void updateSysMessage(SysMessage sysMessage);

    /**
     *  查询全部信息
     * @return
     */
    List<SysMessage> listSysMessage();

    /**
     * 根据id查询消息*标记已读
     * @param id
     * @return
     */
    SysMessage getSysMessageById(Long id);

    /**
     * 系统消息复杂查询，分页，排序
     * @param sysMessage
     * @param pager
     * @return
     */
    ListPager querySysMessageByPager(SysMessage sysMessage, Pager pager);

//    /**
//     * 根据id修改消息状态
//     * @param id
//     * @param status
//     */
//    void updateSysMessageStatusById(String id,Integer status);

    /**
     * 批量删除系统消息
     * @param ids
     */
    void deleteSysMessageByIds(Long[] ids);

//    /**
//     * 批量修改消息状态
//     * @param ids
//     * @param status
//     */
//    void updateSysMessageStatusByIds(String[] ids,Integer status);

    /**
     * 添加用户消息关系表
     * @param refUserMessage
     */
    SysRefUserMessage insertSysRefUserMessage(SysRefUserMessage refUserMessage);

    /**
     * 添加消息并发送
     * @param sysMessage
     * @return
     */
    void doSendSysMessage(SysMessage sysMessage);
}
