package cn.estsh.i3plus.core.apiservice.util;

import cn.estsh.i3plus.platform.common.util.PlatformConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysOrderNoRule;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;

/**
 * @Description : 单号生成工具类
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2018-11-21 13:26
 * @Modify:
 **/
public class OrderNoMakeUtil {

    public static SysOrderNoRule next(SysOrderNoRule orderNoRule) {
        StringBuilder orderNo = new StringBuilder(orderNoRule.getOrderNoRule());

        String[] dateTime = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss").format(System.currentTimeMillis()).split("-");
        replace(orderNo, PlatformConstWords.YEAR, dateTime[0]);
        replace(orderNo, PlatformConstWords.MONTH, dateTime[1]);
        replace(orderNo, PlatformConstWords.DAY, dateTime[2]);
        replace(orderNo, PlatformConstWords.HOUR, dateTime[3]);
        replace(orderNo, PlatformConstWords.MINUTE, dateTime[4]);
        replace(orderNo, PlatformConstWords.SECOND, dateTime[5]);

        // 流水号长度补全
        String serialNumberFormatStr = MessageFormat.format(PlatformConstWords.SERIAL_NO_FORMAT, orderNoRule.getSerialNoLength());

        if (orderNoRule.getLastMakeSerialNo() > 0) {
            int serialNo = orderNoRule.getLastMakeSerialNo() + orderNoRule.getSerialNoIncrement();
            // 达到最大值后循环或继续
            if(orderNoRule.getSerialNoLength().intValue() < String.valueOf(serialNo).length()
                && orderNoRule.getIsCycle() == CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue()){
                orderNoRule.setLastMakeSerialNo(orderNoRule.getSerialNoSeed());
            } else {
                orderNoRule.setLastMakeSerialNo(orderNoRule.getLastMakeSerialNo() + orderNoRule.getSerialNoIncrement());
            }
        } else {
            orderNoRule.setLastMakeSerialNo(orderNoRule.getSerialNoSeed());
        }
        replace(orderNo, PlatformConstWords.SERIAL_NO, String.format(serialNumberFormatStr, orderNoRule.getLastMakeSerialNo()));

        orderNoRule.setLastMakeOrderNo(orderNo.toString());
        return orderNoRule;
    }

    private static StringBuilder replace(StringBuilder no, String constant, String param) {
        int day = no.indexOf(constant);
        if (day != -1) {
            no.replace(day, day + constant.length(), param);
        }
        return no;
    }

}
